Package ghidra.program.util

# Interface ChangeManager

All Known Implementing Classes:
  `ChangeManagerAdapter`, `ProgramDB`

public interface ChangeManager
Interface to define event types and the method to generate an event within Program.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED`
  An AddressSetPropertyMap was added.
  `static final int`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED`
  An AddressSetPropertyMap was changed.
  `static final int`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED`
  An AddressSetPropertyMap was removed.
  `static final int`
  `DOCR_BOOKMARK_ADDED`
  Bookmark was added.
  `static final int`
  `DOCR_BOOKMARK_CHANGED`
  Bookmark category or comment was changed (old value not provided).
  `static final int`
  `DOCR_BOOKMARK_REMOVED`
  Bookmark was deleted.
  `static final int`
  `DOCR_BOOKMARK_TYPE_ADDED`
  Bookmark type was added.
  `static final int`
  `DOCR_BOOKMARK_TYPE_REMOVED`
  Bookmark type was removed.
  `static final int`
  `DOCR_CATEGORY_ADDED`
  Category was added.
  `static final int`
  `DOCR_CATEGORY_MOVED`
  Category was moved.
  `static final int`
  `DOCR_CATEGORY_REMOVED`
  Category was removed.
  `static final int`
  `DOCR_CATEGORY_RENAMED`
  Category was renamed.
  `static final int`
  `DOCR_CODE_ADDED`
  A CodeUnit was added.
  `static final int`
  `DOCR_CODE_MOVED`
  CodeUnits were moved from one Fragment to another.
  `static final int`
  `DOCR_CODE_REMOVED`
  A CodeUnit was removed.
  `static final int`
  `DOCR_CODE_REPLACED`
  Data was replaced.
  `static final int`
  `DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED`
  Generated whenever an entire user property manager is deleted.
  `static final int`
  `DOCR_CODE_UNIT_PROPERTY_CHANGED`
  A property on a code unit was changed.
  `static final int`
  `DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED`
  Property over a range of addresses was removed.
  `static final int`
  `DOCR_CODE_UNIT_USER_DATA_CHANGED`
  The document for a Module changed.
  `static final int`
  `DOCR_COMPOSITE_ADDED`
  Structure was added.
  `static final int`
  `DOCR_COMPOSITE_REMOVED`
  Structure was removed.
  `static final int`
  `DOCR_CUSTOM_FORMAT_ADDED`
  A custom format for a data type was added.
  `static final int`
  `DOCR_CUSTOM_FORMAT_REMOVED`
  A custom format for a data type was removed.
  `static final int`
  `DOCR_DATA_TYPE_ADDED`
  Data type was added to a category.
  `static final int`
  `DOCR_DATA_TYPE_CHANGED`
  Data type was updated.
  `static final int`
  `DOCR_DATA_TYPE_MOVED`
  Data type was moved to another category.
  `static final int`
  `DOCR_DATA_TYPE_REMOVED`
  Data type was removed from a category.
  `static final int`
  `DOCR_DATA_TYPE_RENAMED`
  Data Type was renamed.
  `static final int`
  `DOCR_DATA_TYPE_REPLACED`
  Data type was replaced in a category.
  `static final int`
  `DOCR_DATA_TYPE_SETTING_CHANGED`
  The settings on a data type were updated.
  `static final int`
  `DOCR_DOCUMENT_CHANGED`
  The document for a Module changed.
  `static final int`
  `DOCR_EOL_COMMENT_CHANGED`
  The end-of-line comment changed for a CodeUnit.
  `static final int`
  `DOCR_EQUATE_ADDED`
  An Equate was created.
  `static final int`
  `DOCR_EQUATE_REFERENCE_ADDED`
  A reference at an operand was added to an Equate.
  `static final int`
  `DOCR_EQUATE_REFERENCE_REMOVED`
  A reference at an operand was removed from an Equate.
  `static final int`
  `DOCR_EQUATE_REMOVED`
  An Equate was deleted.
  `static final int`
  `DOCR_EQUATE_RENAMED`
  An Equate was renamed.
  `static final int`
  `DOCR_EXTERNAL_ENTRY_POINT_ADDED`
  An external entry point was added.
  `static final int`
  `DOCR_EXTERNAL_ENTRY_POINT_REMOVED`
  An external entry point was removed.
  `static final int`
  `DOCR_EXTERNAL_NAME_ADDED`
  An external program name was added.
  `static final int`
  `DOCR_EXTERNAL_NAME_CHANGED`
  The name for an external program changed.
  `static final int`
  `DOCR_EXTERNAL_NAME_REMOVED`
  An external program name was removed.
  `static final int`
  `DOCR_EXTERNAL_PATH_CHANGED`
  The external path name changed for an external program name.
  `static final int`
  `DOCR_EXTERNAL_REFERENCE_ADDED`
  An external reference was added.
  `static final int`
  `DOCR_EXTERNAL_REFERENCE_REMOVED`
  An external reference was removed.
  `static final int`
  `DOCR_FALLTHROUGH_CHANGED`
  A Fallthrough address was changed for an instruction.
  `static final int`
  `DOCR_FLOWOVERRIDE_CHANGED`
  The flow override for an instruction has changed.
  `static final int`
  `DOCR_FRAGMENT_MOVED`
  Fragment or set of fragments have been moved.
  `static final int`
  `DOCR_FUNCTION_ADDED`
  Function was added.
  `static final int`
  `DOCR_FUNCTION_BODY_CHANGED`
  A function's body changed.
  `static final int`
  `DOCR_FUNCTION_CHANGED`
  Function was changed.
  `static final int`
  `DOCR_FUNCTION_REMOVED`
  Function was removed.
  `static final int`
  `DOCR_FUNCTION_TAG_CHANGED`
  A function tag was edited
  `static final int`
  `DOCR_FUNCTION_TAG_CREATED`
  A function tag was created
  `static final int`
  `DOCR_FUNCTION_TAG_DELETED`
  A function tag was created
  `static final int`
  `DOCR_GROUP_ADDED`
  A Module or Fragment was added.
  `static final int`
  `DOCR_GROUP_ALIAS_CHANGED`
  The alias for a Module or Fragment changed.
  `static final int`
  `DOCR_GROUP_COMMENT_CHANGED`
  The comment for a Module or Fragment changed.
  `static final int`
  `DOCR_GROUP_REMOVED`
  A Module or Fragment was removed.
  `static final int`
  `DOCR_GROUP_RENAMED`
  A Module or Fragment was renamed.
  `static final int`
  `DOCR_GROUP_REPARENTED`
  Group was reparented.
  `static final int`
  `DOCR_IMAGE_BASE_CHANGED`
  The memory image base has changed.
  `static final int`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED`
  An IntAddressSetPropertyMap was added.
  `static final int`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED`
  An IntAddressSetPropertyMap was changed.
  `static final int`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED`
  An IntAddressSetPropertyMap was removed.
  `static final int`
  `DOCR_LANGUAGE_CHANGED`
  The language for the Program changed.
  `static final int`
  `DOCR_LENGTH_OVERRIDE_CHANGED`
  An instruction length override was changed for an instruction.
  `static final int`
  `DOCR_MEM_REF_PRIMARY_REMOVED`
  The primary reference was removed.
  `static final int`
  `DOCR_MEM_REF_PRIMARY_SET`
  The reference was identified as the primary.
  `static final int`
  `DOCR_MEM_REF_TYPE_CHANGED`
  The ref type on a memory reference changed.
  `static final int`
  `DOCR_MEM_REFERENCE_ADDED`
  A reference was added to a symbol.
  `static final int`
  `DOCR_MEM_REFERENCE_REMOVED`
  A reference was removed from a symbol.
  `static final int`
  `DOCR_MEMORY_BLOCK_ADDED`
  A memory block was created.
  `static final int`
  `DOCR_MEMORY_BLOCK_CHANGED`
  A memory block was changed.
  `static final int`
  `DOCR_MEMORY_BLOCK_MOVED`
  A block of memory was moved to a new start address.
  `static final int`
  `DOCR_MEMORY_BLOCK_REMOVED`
  A memory block was removed.
  `static final int`
  `DOCR_MEMORY_BLOCK_SPLIT`
  A memory block was split into two memory blocks.
  `static final int`
  `DOCR_MEMORY_BLOCKS_JOINED`
  Two memory blocks were joined into a single memory block.
  `static final int`
  `DOCR_MEMORY_BYTES_CHANGED`
  The bytes changed in memory.
  `static final int`
  `DOCR_MODULE_REORDERED`
  The children of a Module have been reordered.
  `static final int`
  `DOCR_OBJECT_CREATED`
  Domain object was created.
  `static final int`
  `DOCR_OVERLAY_SPACE_ADDED`
  An overlay address space was added.
  `static final int`
  `DOCR_OVERLAY_SPACE_REMOVED`
  An overlay address space was removed.
  `static final int`
  `DOCR_OVERLAY_SPACE_RENAMED`
  An overlay address space was renamed.
  `static final int`
  `DOCR_PLATE_COMMENT_CHANGED`
  A Plate comment was added, deleted, or changed.
  `static final int`
  `DOCR_POST_COMMENT_CHANGED`
  The post comment changed for a CodeUnit.
  `static final int`
  `DOCR_PRE_COMMENT_CHANGED`
  The pre comment changed for a CodeUnit.
  `static final int`
  `DOCR_REGISTER_VALUES_CHANGED`
  Register values changed.
  `static final int`
  `DOCR_RELOCATION_ADDED`
  A relocation entry was added
  `static final int`
  `DOCR_REPEATABLE_COMMENT_ADDED`
  A Repeatable Comment was added to a CodeUnit.
  `static final int`
  `DOCR_REPEATABLE_COMMENT_CHANGED`
  A Repeatable Comment changed.
  `static final int`
  `DOCR_REPEATABLE_COMMENT_CREATED`
  A Repeatable Comment was created.
  `static final int`
  `DOCR_REPEATABLE_COMMENT_DELETED`
  A Repeatable Comment was deleted.
  `static final int`
  `DOCR_REPEATABLE_COMMENT_REMOVED`
  A Repeatable Comment was removed from a CodeUnit.
  `static final int`
  `DOCR_SOURCE_ARCHIVE_ADDED`
  Data type was added to a category.
  `static final int`
  `DOCR_SOURCE_ARCHIVE_CHANGED`
  Data type was updated.
  `static final int`
  `DOCR_SYMBOL_ADDED`
  A symbol was created.
  `static final int`
  `DOCR_SYMBOL_ADDRESS_CHANGED`
  Symbol address changed.
  `static final int`
  `DOCR_SYMBOL_ANCHORED_FLAG_CHANGED`
  The anchor flag for the symbol was changed.
  `static final int`
  `DOCR_SYMBOL_ASSOCIATION_ADDED`
  An association to a symbol for a reference was added.
  `static final int`
  `DOCR_SYMBOL_ASSOCIATION_REMOVED`
  An association to a symbol for a reference was removed.
  `static final int`
  `DOCR_SYMBOL_DATA_CHANGED`
  Symbol data changed.
  `static final int`
  `DOCR_SYMBOL_REMOVED`
  A symbol was removed.
  `static final int`
  `DOCR_SYMBOL_RENAMED`
  A symbol was renamed.
  `static final int`
  `DOCR_SYMBOL_SCOPE_CHANGED`
  The scope on a symbol changed.
  `static final int`
  `DOCR_SYMBOL_SET_AS_PRIMARY`
  A symbol was set as primary.
  `static final int`
  `DOCR_SYMBOL_SOURCE_CHANGED`
  The source of a symbol name was changed.
  `static final int`
  `DOCR_TAG_ADDED_TO_FUNCTION`
  A function tag was added to a function.
  `static final int`
  `DOCR_TAG_REMOVED_FROM_FUNCTION`
  A function tag was removed from a function.
  `static final int`
  `DOCR_TREE_CREATED`
  Tree was created.
  `static final int`
  `DOCR_TREE_REMOVED`
  Tree was removed.
  `static final int`
  `DOCR_TREE_RENAMED`
  Tree was renamed.
  `static final int`
  `DOCR_TREE_RESTORED`
  Program Tree hierarchy was restored.
  `static final int`
  `DOCR_USER_DATA_CHANGED`
  A Module or Fragment was added.
  `static final int`
  `DOCR_VARIABLE_REFERENCE_ADDED`
  A function variable reference was added.
  `static final int`
  `DOCR_VARIABLE_REFERENCE_REMOVED`
  A function variable reference was removed.
  `static final int`
  `FUNCTION_CHANGED_CALL_FIXUP`
  A function's call-fixup state was changed.
  `static final int`
  `FUNCTION_CHANGED_INLINE`
  A function's inline state was changed.
  `static final int`
  `FUNCTION_CHANGED_NORETURN`
  A function's no-return state was changed.
  `static final int`
  `FUNCTION_CHANGED_PARAMETERS`
  A functions parameter list was modified
  `static final int`
  `FUNCTION_CHANGED_PURGE`
  A function's purge size was changed.
  `static final int`
  `FUNCTION_CHANGED_RETURN`
  A functions return type/storage was modified
  `static final int`
  `FUNCTION_CHANGED_THUNK`
  A functions thunk status has changed

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setChanged(int type, Address start, Address end, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setChanged(int type, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(int type, int subType, Address addr, Object affectedObj, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(int type, int subType, Object affectedObj, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(int type, Address addr, Object affectedObj, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(int type, AddressSetView addrSet, Object affectedObj, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(int type, Object affectedObj, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setPropertyChanged(String propertyName, Address codeUnitAddr, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_CHANGED event.
  `void`
  `setPropertyRangeRemoved(String propertyName, Address start, Address end)`
  Mark the state of the Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED event.
  `void`
  `setRegisterValuesChanged(Register register, Address start, Address end)`
  Notifies that register values have changed over the indicated address range.

- ## Field Details

  - ### DOCR_MEMORY_BLOCK_ADDED

    static final int DOCR_MEMORY_BLOCK_ADDED
    A memory block was created.
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BLOCK_REMOVED

    static final int DOCR_MEMORY_BLOCK_REMOVED
    A memory block was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BLOCK_CHANGED

    static final int DOCR_MEMORY_BLOCK_CHANGED
    A memory block was changed. (for example: its name, comment, or read, write, or execute flags were changed.)
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BLOCK_MOVED

    static final int DOCR_MEMORY_BLOCK_MOVED
    A block of memory was moved to a new start address.
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BLOCK_SPLIT

    static final int DOCR_MEMORY_BLOCK_SPLIT
    A memory block was split into two memory blocks.
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BLOCKS_JOINED

    static final int DOCR_MEMORY_BLOCKS_JOINED
    Two memory blocks were joined into a single memory block.
    See Also:
      - Constant Field Values

  - ### DOCR_MEMORY_BYTES_CHANGED

    static final int DOCR_MEMORY_BYTES_CHANGED
    The bytes changed in memory.
    See Also:
      - Constant Field Values

  - ### DOCR_IMAGE_BASE_CHANGED

    static final int DOCR_IMAGE_BASE_CHANGED
    The memory image base has changed.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_ADDED

    static final int DOCR_CODE_ADDED
    A CodeUnit was added. The "New Value" may be null when a block of Instructions are added
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_REMOVED

    static final int DOCR_CODE_REMOVED
    A CodeUnit was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_MOVED

    static final int DOCR_CODE_MOVED
    CodeUnits were moved from one Fragment to another.
    See Also:
      - Constant Field Values

  - ### DOCR_COMPOSITE_ADDED

    static final int DOCR_COMPOSITE_ADDED
    Structure was added.
    See Also:
      - Constant Field Values

  - ### DOCR_COMPOSITE_REMOVED

    static final int DOCR_COMPOSITE_REMOVED
    Structure was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_REPLACED

    static final int DOCR_CODE_REPLACED
    Data was replaced.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_UNIT_PROPERTY_CHANGED

    static final int DOCR_CODE_UNIT_PROPERTY_CHANGED
    A property on a code unit was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED

    static final int DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED
    Generated whenever an entire user property manager is deleted.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED

    static final int DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED
    Property over a range of addresses was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_ADDED

    static final int DOCR_SYMBOL_ADDED
    A symbol was created.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_REMOVED

    static final int DOCR_SYMBOL_REMOVED
    A symbol was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_SOURCE_CHANGED

    static final int DOCR_SYMBOL_SOURCE_CHANGED
    The source of a symbol name was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_ANCHORED_FLAG_CHANGED

    static final int DOCR_SYMBOL_ANCHORED_FLAG_CHANGED
    The anchor flag for the symbol was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_SET_AS_PRIMARY

    static final int DOCR_SYMBOL_SET_AS_PRIMARY
    A symbol was set as primary.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_RENAMED

    static final int DOCR_SYMBOL_RENAMED
    A symbol was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_ENTRY_POINT_ADDED

    static final int DOCR_EXTERNAL_ENTRY_POINT_ADDED
    An external entry point was added.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_ENTRY_POINT_REMOVED

    static final int DOCR_EXTERNAL_ENTRY_POINT_REMOVED
    An external entry point was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_SCOPE_CHANGED

    static final int DOCR_SYMBOL_SCOPE_CHANGED
    The scope on a symbol changed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_ASSOCIATION_ADDED

    static final int DOCR_SYMBOL_ASSOCIATION_ADDED
    An association to a symbol for a reference was added.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_ASSOCIATION_REMOVED

    static final int DOCR_SYMBOL_ASSOCIATION_REMOVED
    An association to a symbol for a reference was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_DATA_CHANGED

    static final int DOCR_SYMBOL_DATA_CHANGED
    Symbol data changed. This corresponds to various changes within the symbol (e.g., primary status, datatype, external path or VariableStorage).
    See Also:
      - Constant Field Values

  - ### DOCR_SYMBOL_ADDRESS_CHANGED

    static final int DOCR_SYMBOL_ADDRESS_CHANGED
    Symbol address changed. NOTE: This is only permitted for variable/parameter symbols
    See Also:
      - Constant Field Values

  - ### DOCR_MEM_REFERENCE_ADDED

    static final int DOCR_MEM_REFERENCE_ADDED
    A reference was added to a symbol.
    See Also:
      - Constant Field Values

  - ### DOCR_MEM_REFERENCE_REMOVED

    static final int DOCR_MEM_REFERENCE_REMOVED
    A reference was removed from a symbol.
    See Also:
      - Constant Field Values

  - ### DOCR_MEM_REF_TYPE_CHANGED

    static final int DOCR_MEM_REF_TYPE_CHANGED
    The ref type on a memory reference changed.
    See Also:
      - Constant Field Values

  - ### DOCR_MEM_REF_PRIMARY_SET

    static final int DOCR_MEM_REF_PRIMARY_SET
    The reference was identified as the primary.
    See Also:
      - Constant Field Values

  - ### DOCR_MEM_REF_PRIMARY_REMOVED

    static final int DOCR_MEM_REF_PRIMARY_REMOVED
    The primary reference was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_PATH_CHANGED

    static final int DOCR_EXTERNAL_PATH_CHANGED
    The external path name changed for an external program name.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_NAME_ADDED

    static final int DOCR_EXTERNAL_NAME_ADDED
    An external program name was added.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_NAME_REMOVED

    static final int DOCR_EXTERNAL_NAME_REMOVED
    An external program name was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_NAME_CHANGED

    static final int DOCR_EXTERNAL_NAME_CHANGED
    The name for an external program changed.
    See Also:
      - Constant Field Values

  - ### DOCR_EQUATE_ADDED

    static final int DOCR_EQUATE_ADDED
    An Equate was created.
    See Also:
      - Constant Field Values

  - ### DOCR_EQUATE_REMOVED

    static final int DOCR_EQUATE_REMOVED
    An Equate was deleted.
    See Also:
      - Constant Field Values

  - ### DOCR_EQUATE_REFERENCE_ADDED

    static final int DOCR_EQUATE_REFERENCE_ADDED
    A reference at an operand was added to an Equate.
    See Also:
      - Constant Field Values

  - ### DOCR_EQUATE_REFERENCE_REMOVED

    static final int DOCR_EQUATE_REFERENCE_REMOVED
    A reference at an operand was removed from an Equate.
    See Also:
      - Constant Field Values

  - ### DOCR_EQUATE_RENAMED

    static final int DOCR_EQUATE_RENAMED
    An Equate was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_DOCUMENT_CHANGED

    static final int DOCR_DOCUMENT_CHANGED
    The document for a Module changed.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_ADDED

    static final int DOCR_GROUP_ADDED
    A Module or Fragment was added.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_REMOVED

    static final int DOCR_GROUP_REMOVED
    A Module or Fragment was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_RENAMED

    static final int DOCR_GROUP_RENAMED
    A Module or Fragment was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_COMMENT_CHANGED

    static final int DOCR_GROUP_COMMENT_CHANGED
    The comment for a Module or Fragment changed.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_ALIAS_CHANGED

    static final int DOCR_GROUP_ALIAS_CHANGED
    The alias for a Module or Fragment changed.
    See Also:
      - Constant Field Values

  - ### DOCR_MODULE_REORDERED

    static final int DOCR_MODULE_REORDERED
    The children of a Module have been reordered.
    See Also:
      - Constant Field Values

  - ### DOCR_FRAGMENT_MOVED

    static final int DOCR_FRAGMENT_MOVED
    Fragment or set of fragments have been moved.
    See Also:
      - Constant Field Values

  - ### DOCR_GROUP_REPARENTED

    static final int DOCR_GROUP_REPARENTED
    Group was reparented.
    See Also:
      - Constant Field Values

  - ### DOCR_EOL_COMMENT_CHANGED

    static final int DOCR_EOL_COMMENT_CHANGED
    The end-of-line comment changed for a CodeUnit.
    See Also:
      - Constant Field Values

  - ### DOCR_PRE_COMMENT_CHANGED

    static final int DOCR_PRE_COMMENT_CHANGED
    The pre comment changed for a CodeUnit.
    See Also:
      - Constant Field Values

  - ### DOCR_POST_COMMENT_CHANGED

    static final int DOCR_POST_COMMENT_CHANGED
    The post comment changed for a CodeUnit.
    See Also:
      - Constant Field Values

  - ### DOCR_REPEATABLE_COMMENT_CREATED

    static final int DOCR_REPEATABLE_COMMENT_CREATED
    A Repeatable Comment was created.
    See Also:
      - Constant Field Values

  - ### DOCR_REPEATABLE_COMMENT_ADDED

    static final int DOCR_REPEATABLE_COMMENT_ADDED
    A Repeatable Comment was added to a CodeUnit.
    See Also:
      - Constant Field Values

  - ### DOCR_PLATE_COMMENT_CHANGED

    static final int DOCR_PLATE_COMMENT_CHANGED
    A Plate comment was added, deleted, or changed.
    See Also:
      - Constant Field Values

  - ### DOCR_REPEATABLE_COMMENT_CHANGED

    static final int DOCR_REPEATABLE_COMMENT_CHANGED
    A Repeatable Comment changed.
    See Also:
      - Constant Field Values

  - ### DOCR_REPEATABLE_COMMENT_REMOVED

    static final int DOCR_REPEATABLE_COMMENT_REMOVED
    A Repeatable Comment was removed from a CodeUnit.
    See Also:
      - Constant Field Values

  - ### DOCR_REPEATABLE_COMMENT_DELETED

    static final int DOCR_REPEATABLE_COMMENT_DELETED
    A Repeatable Comment was deleted.
    See Also:
      - Constant Field Values

  - ### DOCR_CATEGORY_ADDED

    static final int DOCR_CATEGORY_ADDED
    Category was added.
    See Also:
      - Constant Field Values

  - ### DOCR_CATEGORY_REMOVED

    static final int DOCR_CATEGORY_REMOVED
    Category was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_CATEGORY_RENAMED

    static final int DOCR_CATEGORY_RENAMED
    Category was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_CATEGORY_MOVED

    static final int DOCR_CATEGORY_MOVED
    Category was moved.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_ADDED

    static final int DOCR_DATA_TYPE_ADDED
    Data type was added to a category.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_REMOVED

    static final int DOCR_DATA_TYPE_REMOVED
    Data type was removed from a category.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_RENAMED

    static final int DOCR_DATA_TYPE_RENAMED
    Data Type was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_MOVED

    static final int DOCR_DATA_TYPE_MOVED
    Data type was moved to another category.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_CHANGED

    static final int DOCR_DATA_TYPE_CHANGED
    Data type was updated.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_SETTING_CHANGED

    static final int DOCR_DATA_TYPE_SETTING_CHANGED
    The settings on a data type were updated.
    See Also:
      - Constant Field Values

  - ### DOCR_DATA_TYPE_REPLACED

    static final int DOCR_DATA_TYPE_REPLACED
    Data type was replaced in a category.
    See Also:
      - Constant Field Values

  - ### DOCR_SOURCE_ARCHIVE_ADDED

    static final int DOCR_SOURCE_ARCHIVE_ADDED
    Data type was added to a category.
    See Also:
      - Constant Field Values

  - ### DOCR_SOURCE_ARCHIVE_CHANGED

    static final int DOCR_SOURCE_ARCHIVE_CHANGED
    Data type was updated.
    See Also:
      - Constant Field Values

  - ### DOCR_BOOKMARK_TYPE_ADDED

    static final int DOCR_BOOKMARK_TYPE_ADDED
    Bookmark type was added.
    See Also:
      - Constant Field Values

  - ### DOCR_BOOKMARK_TYPE_REMOVED

    static final int DOCR_BOOKMARK_TYPE_REMOVED
    Bookmark type was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_BOOKMARK_ADDED

    static final int DOCR_BOOKMARK_ADDED
    Bookmark was added.
    See Also:
      - Constant Field Values

  - ### DOCR_BOOKMARK_REMOVED

    static final int DOCR_BOOKMARK_REMOVED
    Bookmark was deleted.
    See Also:
      - Constant Field Values

  - ### DOCR_BOOKMARK_CHANGED

    static final int DOCR_BOOKMARK_CHANGED
    Bookmark category or comment was changed (old value not provided).
    See Also:
      - Constant Field Values

  - ### DOCR_LANGUAGE_CHANGED

    static final int DOCR_LANGUAGE_CHANGED
    The language for the Program changed.
    See Also:
      - Constant Field Values

  - ### DOCR_REGISTER_VALUES_CHANGED

    static final int DOCR_REGISTER_VALUES_CHANGED
    Register values changed.
    See Also:
      - Constant Field Values

  - ### DOCR_OBJECT_CREATED

    static final int DOCR_OBJECT_CREATED
    Domain object was created.
    See Also:
      - Constant Field Values

  - ### DOCR_OVERLAY_SPACE_ADDED

    static final int DOCR_OVERLAY_SPACE_ADDED
    An overlay address space was added.
    See Also:
      - Constant Field Values

  - ### DOCR_OVERLAY_SPACE_REMOVED

    static final int DOCR_OVERLAY_SPACE_REMOVED
    An overlay address space was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_OVERLAY_SPACE_RENAMED

    static final int DOCR_OVERLAY_SPACE_RENAMED
    An overlay address space was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_TREE_RESTORED

    static final int DOCR_TREE_RESTORED
    Program Tree hierarchy was restored.
    See Also:
      - Constant Field Values

  - ### DOCR_TREE_CREATED

    static final int DOCR_TREE_CREATED
    Tree was created.
    See Also:
      - Constant Field Values

  - ### DOCR_TREE_REMOVED

    static final int DOCR_TREE_REMOVED
    Tree was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_TREE_RENAMED

    static final int DOCR_TREE_RENAMED
    Tree was renamed.
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_TAG_CHANGED

    static final int DOCR_FUNCTION_TAG_CHANGED
    A function tag was edited
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_TAG_CREATED

    static final int DOCR_FUNCTION_TAG_CREATED
    A function tag was created
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_TAG_DELETED

    static final int DOCR_FUNCTION_TAG_DELETED
    A function tag was created
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_ADDED

    static final int DOCR_FUNCTION_ADDED
    Function was added.
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_REMOVED

    static final int DOCR_FUNCTION_REMOVED
    Function was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_CHANGED

    static final int DOCR_FUNCTION_CHANGED
    Function was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_VARIABLE_REFERENCE_ADDED

    static final int DOCR_VARIABLE_REFERENCE_ADDED
    A function variable reference was added.
    See Also:
      - Constant Field Values

  - ### DOCR_VARIABLE_REFERENCE_REMOVED

    static final int DOCR_VARIABLE_REFERENCE_REMOVED
    A function variable reference was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_FUNCTION_BODY_CHANGED

    static final int DOCR_FUNCTION_BODY_CHANGED
    A function's body changed.
    See Also:
      - Constant Field Values

  - ### DOCR_TAG_ADDED_TO_FUNCTION

    static final int DOCR_TAG_ADDED_TO_FUNCTION
    A function tag was added to a function.
    See Also:
      - Constant Field Values

  - ### DOCR_TAG_REMOVED_FROM_FUNCTION

    static final int DOCR_TAG_REMOVED_FROM_FUNCTION
    A function tag was removed from a function.
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_PURGE

    static final int FUNCTION_CHANGED_PURGE
    A function's purge size was changed.
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_INLINE

    static final int FUNCTION_CHANGED_INLINE
    A function's inline state was changed.
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_NORETURN

    static final int FUNCTION_CHANGED_NORETURN
    A function's no-return state was changed.
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_CALL_FIXUP

    static final int FUNCTION_CHANGED_CALL_FIXUP
    A function's call-fixup state was changed.
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_RETURN

    static final int FUNCTION_CHANGED_RETURN
    A functions return type/storage was modified
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_PARAMETERS

    static final int FUNCTION_CHANGED_PARAMETERS
    A functions parameter list was modified
    See Also:
      - Constant Field Values

  - ### FUNCTION_CHANGED_THUNK

    static final int FUNCTION_CHANGED_THUNK
    A functions thunk status has changed
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_REFERENCE_ADDED

    static final int DOCR_EXTERNAL_REFERENCE_ADDED
    An external reference was added.
    See Also:
      - Constant Field Values

  - ### DOCR_EXTERNAL_REFERENCE_REMOVED

    static final int DOCR_EXTERNAL_REFERENCE_REMOVED
    An external reference was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_FALLTHROUGH_CHANGED

    static final int DOCR_FALLTHROUGH_CHANGED
    A Fallthrough address was changed for an instruction.
    See Also:
      - Constant Field Values

  - ### DOCR_FLOWOVERRIDE_CHANGED

    static final int DOCR_FLOWOVERRIDE_CHANGED
    The flow override for an instruction has changed.
    See Also:
      - Constant Field Values

  - ### DOCR_LENGTH_OVERRIDE_CHANGED

    static final int DOCR_LENGTH_OVERRIDE_CHANGED
    An instruction length override was changed for an instruction.
    See Also:
      - Constant Field Values

  - ### DOCR_CUSTOM_FORMAT_ADDED

    static final int DOCR_CUSTOM_FORMAT_ADDED
    A custom format for a data type was added.
    See Also:
      - Constant Field Values

  - ### DOCR_CUSTOM_FORMAT_REMOVED

    static final int DOCR_CUSTOM_FORMAT_REMOVED
    A custom format for a data type was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED

    static final int DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED
    An AddressSetPropertyMap was added.
    See Also:
      - Constant Field Values

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED

    static final int DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED
    An AddressSetPropertyMap was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED

    static final int DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED
    An AddressSetPropertyMap was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED

    static final int DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED
    An IntAddressSetPropertyMap was added.
    See Also:
      - Constant Field Values

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED

    static final int DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED
    An IntAddressSetPropertyMap was removed.
    See Also:
      - Constant Field Values

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED

    static final int DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED
    An IntAddressSetPropertyMap was changed.
    See Also:
      - Constant Field Values

  - ### DOCR_CODE_UNIT_USER_DATA_CHANGED

    static final int DOCR_CODE_UNIT_USER_DATA_CHANGED
    The document for a Module changed.
    See Also:
      - Constant Field Values

  - ### DOCR_USER_DATA_CHANGED

    static final int DOCR_USER_DATA_CHANGED
    A Module or Fragment was added.
    See Also:
      - Constant Field Values

  - ### DOCR_RELOCATION_ADDED

    static final int DOCR_RELOCATION_ADDED
    A relocation entry was added
    See Also:
      - Constant Field Values

- ## Method Details

  - ### setChanged

    void setChanged(int type, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setRegisterValuesChanged

    void setRegisterValuesChanged(Register register, Address start, Address end)
    Notifies that register values have changed over the indicated address range.
    Parameters:
      `register` - register value which was modified (a value of null indicates all registers affected or unknown)
      `start` - the start address for the range where values changed
      `end` - the end address (inclusive) for the range where values changed

  - ### setChanged

    void setChanged(int type, Address start, Address end, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `start` - starting address that is affected by the event
      `end` - ending address that is affected by the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(int type, Object affectedObj, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `affectedObj` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(int type, int subType, Object affectedObj, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `subType` - event sub-type
      `affectedObj` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(int type, Address addr, Object affectedObj, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `addr` - program address affected
      `affectedObj` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(int type, int subType, Address addr, Object affectedObj, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `subType` - event sub-type
      `addr` - program address affected
      `affectedObj` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(int type, AddressSetView addrSet, Object affectedObj, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `type` - event type
      `addrSet` - set of program addresses affected
      `affectedObj` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setPropertyChanged

    void setPropertyChanged(String propertyName, Address codeUnitAddr, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_CHANGED event.
    Parameters:
      `propertyName` - name of property for the range that changed
      `codeUnitAddr` - address of the code unit with the property change
      `oldValue` - old value for the property
      `newValue` - new value for the property

  - ### setPropertyRangeRemoved

    void setPropertyRangeRemoved(String propertyName, Address start, Address end)
    Mark the state of the Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED event.
    Parameters:
      `propertyName` - name of property for the range being removed
      `start` - start address of the range
      `end` - end address of the range